import { Construct } from 'constructs';
export declare enum Type {
    CLUSTER = "Cluster",
    INSTANCE = "Instance"
}
export interface IdentifiersProperty {
    readonly [name: string]: StatusProperty;
}
export interface StatusProperty {
    readonly stopSchedule: ScheduleProperty;
    readonly startSchedule: ScheduleProperty;
}
export interface ScheduleProperty {
    readonly timezone: string;
    readonly minute?: string;
    readonly hour?: string;
    readonly week?: string;
}
export interface RdsDatabaseRunningSchedulerProps {
    readonly type: Type;
    readonly identifiers: IdentifiersProperty;
}
export declare class RdsDatabaseRunningScheduler extends Construct {
    constructor(scope: Construct, id: string, props: RdsDatabaseRunningSchedulerProps);
}
